/* 
 * phc -- the open source PHP compiler 
 * See license/README.license for licensing information
 *
 * Remove concatenations to empty strings (which are generated by the parser)
 */

#include "Remove_concat_null.h" 

AST_expr* Remove_concat_null::post_bin_op(AST_bin_op* in)
{
	Token_string* empty = new Token_string(new String(""), new String(""));

	// Replace with right operand if left operand is the empty string 
	if(in->match(new AST_bin_op(empty, WILDCARD, ".")))
		return in->right;

	// Replace with left operand if right operand is the empty string 
	if(in->match(new AST_bin_op(WILDCARD, empty, ".")))
		return in->left;
	
	return in;
}
